<?php

###########################################################################
##  Copyright (C) Wizardry and Steamworks 2017 - License: GNU GPLv3      ##
###########################################################################

require_once('inc/pseudocrypt.php');
require_once('inc/functions.php');
require_once('config.php');

#### Retrieve uploaded file.
if (!empty($_FILES['file']) and
    is_uploaded_file($_FILES['file']['tmp_name'])) {
    # Regular multipart/form-data upload.
    $name = $_FILES['file']['name'];
    $data = file_get_contents($_FILES['file']['tmp_name']);
} else {
    # Raw POST data.
    $name = urldecode(@$_SERVER['HTTP_X_FILE_NAME']);
    $data = file_get_contents("php://input");
}

$fileExtension = pathinfo($name, PATHINFO_EXTENSION);

#### Check that the file extension is allowed.
if(!isset($fileExtension) || 
    !in_array(strtoupper($fileExtension), $ALLOWED_FILE_EXTENSIONS))
    return;

#### Hash filename and check storage in the upload folder.
$storePath = realpath($STORE_FOLDER);
$file = strtolower(
    PseudoCrypt::hash(
        preg_replace(
            '/\D/',
            '',
            hash(
                'sha512',
                $name
            )
        )
    ).
    '.'.
    $fileExtension
);
$userPath = join(
    DIRECTORY_SEPARATOR,
    array(
        $STORE_FOLDER,
        $file
    )
);

#### Check for path traversals.
$pathPart = pathinfo($userPath);
if (realpath($pathPart['dirname']) == $storePath) {
    atomized_put_contents($userPath, $data);
    $output = sprintf('%s/%s', trim($URL_PATH, '/'), $file);
}

### Return the URL to the file.
header('Content-Type: text/plain; charset=utf-8');
echo $output;
